package core

import (
	"git.akyoto.dev/cli/q/src/ast"
	"git.akyoto.dev/cli/q/src/errors"
	"git.akyoto.dev/cli/q/src/token"
)

// CompileTokens compiles a token list.
func (f *Function) CompileTokens(tokens []token.Token) error {
	body, err := ast.Parse(tokens, f.File.Bytes)

	if err != nil {
		err.(*errors.Error).File = f.File
		return err
	}

	return f.CompileAST(body)
}
